# Class BioModel

java.lang.Object
org.jmol.modelset.Model
org.jmol.modelsetbio.BioModel

public final class BioModel extends Model

## Field Summary

Fields
Modifier and Type
Field
Description
`BioPolymer[]`
`bioPolymers`

### Fields inherited from class Model

`act, altLocCount, auxiliaryInfo, biosymmetry, bsAsymmetricUnit, bsAtoms, bsAtomsDeleted, chainCount, chains, dataFrames, dataSourceFrame, dssrCache, firstAtomIndex, frameDelay, groupCount, hasRasmolHBonds, hydrogenCount, isBioModel, isJmolDataFrame, isModelKit, isOrderly, isPdbWithMultipleBonds, jmolFrameType, jmolFrameTypeInt, loadScript, loadState, mat4, modelIndex, moleculeCount, ms, orientation, pdbID, properties, selectedTrajectory, simpleCage, structureTainted, trajectoryBaseIndex, uvw, uvw0`

## Constructor Summary

Constructors
Constructor
Description
`BioModel()`

## Method Summary

Modifier and Type
Method
Description
`void`
`fixIndices(int modelIndex, int nAtomsDeleted, BS bsDeleted)`
`boolean`
`freeze()`
`void`
`getAtomicDSSRData(float[] dssrData, String dataType)`
`Lst<BS>`
`getBioBranches(Lst<BS> biobranches)`
`int`
`getBioPolymerCount()`
`void`
`getConformation(int conformationIndex0, boolean doSet, BS bsAtoms, BS bsRet)`
`void`
`getDefaultLargePDBRendering(SB sb, int maxAtoms)`
`String`
`getFullPDBHeader()`
`void`
`getPdbData(String type, char ctype, boolean isDraw, BS bsSelected, OC out, LabelToken[] tokens, SB pdbCONECT, BS bsWritten)`
`String`
`getUnitID(Atom atom, int flags)`
Get a unitID.
`void`
`resetRasmolBonds(BS bs, int dsspVersion)`
from Trajectory.setAtomPositions base models only; not trajectories

### Methods inherited from class Model

`fixIndicesM, freezeM, getBondCount, getChainAt, getChainCount, getGroupCount, getTrueAtomCount, getUVWMatrix, isContainedIn, resetBoundCount, resetDSSR, set, setSimpleCage, setupArrays`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### bioPolymers

public BioPolymer[] bioPolymers

## Constructor Details

### BioModel

public BioModel()

## Method Details

### fixIndices

public void fixIndices(int modelIndex, int nAtomsDeleted, BS bsDeleted)

Overrides:
  `fixIndices` in class `Model`

### freeze

public boolean freeze()

Overrides:
  `freeze` in class `Model`

### getBioBranches

public Lst<BS> getBioBranches(Lst<BS> biobranches)

### getBioPolymerCount

public int getBioPolymerCount()

### getConformation

public void getConformation(int conformationIndex0, boolean doSet, BS bsAtoms, BS bsRet)

Parameters:
  `conformationIndex0` -
  `doSet` -
  `bsAtoms` -
  `bsRet` - to be set

### getDefaultLargePDBRendering

public void getDefaultLargePDBRendering(SB sb, int maxAtoms)

### getFullPDBHeader

public String getFullPDBHeader()

### getPdbData

public void getPdbData(String type, char ctype, boolean isDraw, BS bsSelected, OC out, LabelToken[] tokens, SB pdbCONECT, BS bsWritten)

### getUnitID

public String getUnitID(Atom atom, int flags)
Get a unitID. Note that we MUST go through the | after InsCode, because if we do not do that we cannot match residues only using string matching.

Parameters:
  `atom` -
  `flags` -
Returns:
  a unitID

### resetRasmolBonds

public void resetRasmolBonds(BS bs, int dsspVersion)
from Trajectory.setAtomPositions base models only; not trajectories

Parameters:
  `bs` -
  `dsspVersion` -

### getAtomicDSSRData

public void getAtomicDSSRData(float[] dssrData, String dataType)